﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    class Course // egyetemi kurzus típusa
    {
        private String _Name; // kurzus neve
        private List<Student> _Students; // kurzus hallgatói
        private Teacher _Teacher; // kurzus oktatója

        public String Name { get { return _Name; } }
        public Teacher Teacher { get { return _Teacher; } }
        public Int32 StudentCount { get { return _Students.Count; } }

        public Course(Teacher teacher, String name)
        {
            _Name = name;
            _Teacher = teacher;
            _Students = new List<Student>();

            _ListOfCourses.Add(this); // kurzus felvétele az összes kurzus közé
        }

        public Boolean AddStudent(Student student) // hallgató felvétele
        {
            if (!_Students.Contains(student)) // ha még nincs benne a névsorban
            {
                _Students.Add(student); // vegyük fel
                return true; // jelezzük, hogy sikeres volt a felvétel
            }
            else
                return false;
        }

        public List<Student> GetStudentsList(Teacher teacher) // hallgatók listájának lekérdezése
        {
            if (teacher == _Teacher) // ha a kurzus oktatója
                return _Students; // akkor lekérdezheti a hallgatók listáját, és módosíthatja is azt
            else
                return new List<Student>(); // különben egy üres listát kap
        }

        public List<Student> GetStudentsList(Student student)
        {
            if (_Students.Contains(student)) // ha hallgatója a kurzusnak
                return new List<Student>(_Students); // akkor megkapja a lista másolatát, így nem tudja módosítani az eredetit
            else
                return new List<Student>(); // különben egy üres listát kap
        }

        // osztályszintű tagok:
        private static List<Course> _ListOfCourses = new List<Course>(); // statikus lista, az összes kurzusnak

        public static List<String> ListedCourseNames // statikus tulajdonság, a kurzusnevek lekérdezésére
        {
            get
            {
                List<String> courseNames = new List<String>();
                foreach (Course course in _ListOfCourses)
                    courseNames.Add(course.Name); // létrehozunk egy új listát a kurzusokból
                return courseNames;
            }
        }

        public static Course GetCourse(String name) // statikus metódus, adott nevű kurzus lekérdezése az összesből
        {
            foreach (Course course in _ListOfCourses)
                if (course.Name == name) // ha sikerült megtalálnunk
                    return course; // akkor visszaadjuk
            return null; // különben nullát adunk vissza
        }
    }
}
